## ros-melodic-librealsense2 2.50.0

=== CMakeLists.txt ===
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)
project(librealsense2 LANGUAGES CXX C)

include(CMake/lrs_options.cmake)
include(CMake/connectivity_check.cmake)
#Deprecation message, should be removed in future releases
if(${FORCE_LIBUVC} OR ${FORCE_WINUSB_UVC} OR ${ANDROID_USB_HOST_UVC})
    MESSAGE(DEPRECATION "FORCE_LIBUVC, FORCE_WINUSB_UVC and ANDROID_USB_HOST_UVC are deprecated, use FORCE_RSUSB_BACKEND instead")
    set(FORCE_RSUSB_BACKEND ON)
endif()

# Checking Internet connection, as TM2 needs to download the FW from amazon cloud
if(BUILD_WITH_TM2 AND NOT INTERNET_CONNECTION)
    message(WARNING "No internet connection, disabling BUILD_WITH_TM2")
    set(BUILD_WITH_TM2 OFF)
endif()

# Checking Internet connection, as DEPTH CAM needs to download the FW from amazon cloud
if(IMPORT_DEPTH_CAM_FW AND NOT INTERNET_CONNECTION)
    message(WARNING "No internet connection, disabling IMPORT_DEPTH_CAM_FW")
    set(IMPORT_DEPTH_CAM_FW OFF)
endif()

if (BUILD_PC_STITCHING AND NOT BUILD_GLSL_EXTENSIONS)
    MESSAGE(STATUS "BUILD_PC_STITCHING explicitely depends on BUILD_GLSL_EXTENSIONS, set it ON")
    SET(BUILD_GLSL_EXTENSIONS ON)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/CMake)

# include librealsense general configuration
include(CMake/global_config.cmake)


config_cxx_flags()

# include os specific macros
# macro definition located at "CMake/global_config.cmake"
include(CMake/include_os.cmake)

# set os specific configuration flags
# macro definition located at "CMake/<OS>_config.cmake"
os_set_flags()

# set global configuration flags
# macro definition located at "CMake/global_config.cmake"
global_set_flags()

if(BUILD_SHARED_LIBS)
    add_library(${LRS_TARGET} SHARED "")
else()
    add_library(${LRS_TARGET} STATIC "")
endif()

# set library version
set_target_properties(${LRS_TARGET} PROPERTIES VERSION ${REALSENSE_VERSION_STRING} SOVERSION "${REALSENSE_VERSION_MAJOR}.${REALSENSE_VERSION_MINOR}")

include(include/CMakeLists.txt)
include(src/CMakeLists.txt)
include(third-party/CMakeLists.txt)
include(common/utilities/CMakeLists.txt)

# configure the project according to OS specific requirments
# macro definition located at "CMake/<OS>_config.cmake"
os_target_config()

# global project configuration
# macro definition located at "CMake/global_config.cmake"
global_target_config()

include(CMake/install_config.cmake)

add_subdirectory(wrappers)
if ( ( BUILD_EXAMPLES OR BUILD_PC_STITCHING ) AND BUILD_GLSL_EXTENSIONS )
    find_package(glfw3 3.3 QUIET)
    if(NOT TARGET glfw)
        message(STATUS "GLFW 3.3 not found; using internal version")
        set(GLFW_INSTALL ON CACHE BOOL "" FORCE)
        add_subdirectory(third-party/glfw)
    endif()
    add_subdirectory(src/gl)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
    add_subdirectory(tools)
elseif(BUILD_TOOLS)
    add_subdirectory(tools)
endif()

if(BUILD_UNIT_TESTS OR BUILD_LEGACY_LIVE_TEST)
    add_subdirectory(unit-tests)
endif()

if(BUILD_NETWORK_DEVICE)
    add_subdirectory(src/ethernet)
    add_subdirectory(src/compression)
endif()

if(BUILD_WITH_TM2)
    add_tm2()
endif()

if(IMPORT_DEPTH_CAM_FW)
    add_subdirectory(common/fw)
endif()

include(CMake/embedd_udev_rules.cmake)

=== common/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.

set(COMMON_SRC
        "${CMAKE_CURRENT_LIST_DIR}/animated.h"
        "${CMAKE_CURRENT_LIST_DIR}/float2.h"
        "${CMAKE_CURRENT_LIST_DIR}/float3.h"
        "${CMAKE_CURRENT_LIST_DIR}/float4.h"
        "${CMAKE_CURRENT_LIST_DIR}/matrix4.h"
        "${CMAKE_CURRENT_LIST_DIR}/rect.h"
        "${CMAKE_CURRENT_LIST_DIR}/rendering.h"
        "${CMAKE_CURRENT_LIST_DIR}/model-views.h"
        "${CMAKE_CURRENT_LIST_DIR}/model-views.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/notifications.h"
        "${CMAKE_CURRENT_LIST_DIR}/notifications.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/calibration-model.h"
        "${CMAKE_CURRENT_LIST_DIR}/calibration-model.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/viewer.h"
        "${CMAKE_CURRENT_LIST_DIR}/viewer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/ux-window.h"
        "${CMAKE_CURRENT_LIST_DIR}/ux-window.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/ux-alignment.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/ux-alignment.h"
        "${CMAKE_CURRENT_LIST_DIR}/opengl3.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/opengl3.h"
        "${CMAKE_CURRENT_LIST_DIR}/rs-config.h"
        "${CMAKE_CURRENT_LIST_DIR}/rs-config.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/os.h"
        "${CMAKE_CURRENT_LIST_DIR}/os.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/fw-update-helper.h"
        "${CMAKE_CURRENT_LIST_DIR}/fw-update-helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/metadata-helper.h"
        "${CMAKE_CURRENT_LIST_DIR}/metadata-helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/output-model.h"
        "${CMAKE_CURRENT_LIST_DIR}/output-model.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/skybox.h"
        "${CMAKE_CURRENT_LIST_DIR}/skybox.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/measurement.h"
        "${CMAKE_CURRENT_LIST_DIR}/measurement.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/on-chip-calib.h"
        "${CMAKE_CURRENT_LIST_DIR}/on-chip-calib.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/decompress-huffman.h"
        "${CMAKE_CURRENT_LIST_DIR}/updates-model.h"
        "${CMAKE_CURRENT_LIST_DIR}/updates-model.cpp"
        )

    set(SW_UPDATE_FILES
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/http-downloader.h"
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/http-downloader.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/dev-updates-profile.h"
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/dev-updates-profile.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/versions-db-manager.h"
        "${CMAKE_CURRENT_LIST_DIR}/sw-update/versions-db-manager.cpp"
        )

    set(REFLECTIVITY_FILES
        "${CMAKE_CURRENT_LIST_DIR}/reflectivity/reflectivity.h"
        "${CMAKE_CURRENT_LIST_DIR}/reflectivity/reflectivity.cpp"
        )

    set(UTILITIES_FILES
        "${CMAKE_CURRENT_LIST_DIR}/utilities/number/stabilized-value.h"
        "${CMAKE_CURRENT_LIST_DIR}/utilities/string/split.h"
        "${CMAKE_CURRENT_LIST_DIR}/utilities/string/string-utilities.h"
        "${CMAKE_CURRENT_LIST_DIR}/utilities/string/trim-newlines.h"
        "${CMAKE_CURRENT_LIST_DIR}/utilities/imgui/wrap.h"
        "${CMAKE_CURRENT_LIST_DIR}/utilities/imgui/wrap.cpp"
        )
if (WIN32)
    list(APPEND UTILITIES_FILES
        "${CMAKE_CURRENT_LIST_DIR}/utilities/string/windows.h"
        )
endif()

    set(COMMON_SRC
        ${COMMON_SRC}
        ${SW_UPDATE_FILES}
        ${REFLECTIVITY_FILES}
        ${UTILITIES_FILES}
        )

=== examples/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamples)

# Save the command line compile commands in the build output
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
# View the makefile commands during build
#set(CMAKE_VERBOSE_MAKEFILE on)

if(BUILD_GRAPHICAL_EXAMPLES)
    include(${CMAKE_SOURCE_DIR}/CMake/opengl_config.cmake)
else()
    if(ANDROID_NDK_TOOLCHAIN_INCLUDED)
        find_library(log-lib log)
        set(DEPENDENCIES realsense2 log)
    else()
        set(DEPENDENCIES realsense2)
    endif()
endif()

add_subdirectory(hello-realsense)
add_subdirectory(software-device)
add_subdirectory(capture)
add_subdirectory(callback)
add_subdirectory(save-to-disk)
add_subdirectory(multicam)
add_subdirectory(pointcloud)
add_subdirectory(align)
add_subdirectory(align-advanced)
add_subdirectory(sensor-control)
add_subdirectory(measure)
add_subdirectory(C/depth)
add_subdirectory(C/color)
add_subdirectory(C/distance)
add_subdirectory(post-processing)
add_subdirectory(record-playback)
add_subdirectory(motion)
add_subdirectory(gl)
if(BUILD_NETWORK_DEVICE)
    add_subdirectory(gl-net)
endif()
add_subdirectory(pose)
add_subdirectory(pose-predict)
add_subdirectory(pose-and-image)
add_subdirectory(trajectory)
add_subdirectory(ar-basic)
add_subdirectory(ar-advanced)
add_subdirectory(pose-apriltag)
add_subdirectory(tracking-and-depth)
add_subdirectory(hdr)

=== include/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
target_sources(${LRS_TARGET}
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/rs.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/rs.h"

        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_types.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_context.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_device.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_frame.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_option.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_processing.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_record_playback.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_sensor.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_internal.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_pipeline.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_config.h"

        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_types.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_context.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_device.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_serializable_device.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_export.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_frame.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_processing.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_record_playback.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_sensor.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_options.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_internal.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/hpp/rs_pipeline.hpp"

        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/rsutil.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/rs_advanced_mode.h"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/rs_advanced_mode.hpp"
        "${CMAKE_CURRENT_LIST_DIR}/librealsense2/h/rs_advanced_mode_command.h"
)

=== third-party/CMakeLists.txt ===
string(REPLACE ${PROJECT_SOURCE_DIR}/ "" _rel_path ${CMAKE_CURRENT_LIST_DIR})

# Add additional include directories to allow file to include rosbag headers
include(${_rel_path}/realsense-file/config.cmake)

include(${_rel_path}/sqlite/CMakeLists.txt)

if(BUILD_EASYLOGGINGPP)
    include(${_rel_path}/easyloggingpp/CMakeLists.txt)
endif()

add_subdirectory(${_rel_path}/realsense-file)

if(BUILD_NETWORK_DEVICE)

    add_subdirectory(${_rel_path}/live555)

    include(ExternalProject)

    ### libjpeg-turbo ###################################################
    ExternalProject_Add (libjpeg-turbo
        PREFIX libjpeg-turbo
        GIT_REPOSITORY "https://github.com/libjpeg-turbo/libjpeg-turbo.git"
        GIT_TAG "main"
        SOURCE_DIR "${CMAKE_BINARY_DIR}/third-party/libjpeg-turbo"
        CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/libjpeg-turbo"
          "-DCMAKE_GENERATOR=${CMAKE_GENERATOR}"
          "-DCMAKE_POSITION_INDEPENDENT_CODE=ON"
          "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}"
    )

endif()

=== common/fw/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
cmake_minimum_required(VERSION 3.1.3)

project(fw)

file(READ "firmware-version.h" ver)

message(STATUS "Fetching recommended firmwares:")

set(REALSENSE_FIRMWARE_URL "https://librealsense.intel.com" CACHE STRING
    "URL to download firmware binaries from")

string(REGEX MATCH "D4XX_RECOMMENDED_FIRMWARE_VERSION \"([0-9]+.[0-9]+.[0-9]+.[0-9]+)\"" _ ${ver})
set(D4XX_FW_VERSION ${CMAKE_MATCH_1})
message(STATUS "D4XX_FW_VERSION: ${D4XX_FW_VERSION}")
set(D4XX_FW_SHA1 d5502ba0c51a9994caca72123ce19735bbbbbf97)
set(D4XX_FW_URL "${REALSENSE_FIRMWARE_URL}/Releases/RS4xx/FW")


string(REGEX MATCH "SR3XX_RECOMMENDED_FIRMWARE_VERSION \"([0-9]+.[0-9]+.[0-9]+.[0-9]+)\"" _ ${ver})
set(SR3XX_FW_VERSION ${CMAKE_MATCH_1})
message(STATUS "SR3XX_FW_VERSION: ${SR3XX_FW_VERSION}")
set(SR3XX_FW_SHA1 55237dba5d7db20e7c218975375d05b4210e9460)
set(SR3XX_FW_URL "${REALSENSE_FIRMWARE_URL}/Releases/SR300/FW")

string(REGEX MATCH "T26X_FIRMWARE_VERSION \"([0-9]+.[0-9]+.[0-9]+.[0-9]+)\"" _ ${ver})
set(T26X_FW_VERSION ${CMAKE_MATCH_1})
message(STATUS "T26X_FW_VERSION: ${T26X_FW_VERSION}")
set(T26X_FW_SHA1 c3940ccbb0e3045603e4aceaa2d73427f96e24bc)
set(T26X_FW_URL "${REALSENSE_FIRMWARE_URL}/Releases/TM2/FW/target/${T26X_FW_VERSION}")

string(REGEX MATCH "L51X_RECOMMENDED_FIRMWARE_VERSION \"([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\"" _ ${ver})
set(L51X_FW_VERSION ${CMAKE_MATCH_1})
message(STATUS "L51X_FW_VERSION: ${L51X_FW_VERSION}")
set(L51X_FW_SHA1 ab73e5bfc520c0aa0340cada4b3e317b8fd31a4d)
set(L51X_FW_URL "${REALSENSE_FIRMWARE_URL}/Releases/L5xx/FW")

string(REGEX MATCH "L53X_RECOMMENDED_FIRMWARE_VERSION \"([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)\"" _ ${ver})
set(L53X_FW_VERSION ${CMAKE_MATCH_1})
message(STATUS "L53X_FW_VERSION: ${L53X_FW_VERSION}")
set(L53X_FW_SHA1 9bc28aaf079b105d9a20a0bd845ea222b8754571)
set(L53X_FW_URL "${REALSENSE_FIRMWARE_URL}/Releases/L5xx/FW")

add_library(${PROJECT_NAME} STATIC empty.c)

if (MSVC)
  # lib.exe can't handle multiple .res files, so include them in one.
  # even then, the linker won't grab a .res out of a .lib object, so it needs to be explicitly listed
  # and to find the name of the .res file (across cmake generators) we need to create our own rule. :(
  add_custom_command(TARGET ${PROJECT_NAME} BYPRODUCTS ${PROJECT_NAME}.res COMMAND ${CMAKE_RC_COMPILER} ${CMAKE_RC_FLAGS} /I . /fo "${PROJECT_NAME}.res" "${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc")
  target_link_libraries(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.res")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
set_target_properties (${PROJECT_NAME} PROPERTIES FOLDER Resources)

function(target_binary url version sha1 symbol ext)
  set(binary "${CMAKE_CURRENT_BINARY_DIR}/${symbol}-${version}${ext}")
  message(STATUS "${url}/${symbol}-${version}${ext}")
  file(DOWNLOAD "${url}/${symbol}-${version}${ext}" "${binary}"
       EXPECTED_HASH SHA1=${sha1}
       STATUS status)
  list(GET status 0 error_code)
  if (NOT ${error_code} EQUAL 0)
    message(FATAL_ERROR "Download firmwnare (${status}) - ${url}")
  else()
    message(STATUS "Download firmware ${status} for ${symbol}-${version}${ext}")
  endif()
  string(TOUPPER ${symbol} SYMBOL)
  string(REPLACE "." "," version_commas ${version})
  string(REPLACE "\\" "\\\\" binary_escaped "${binary}")
  configure_file(fw.c.in  "${CMAKE_CURRENT_BINARY_DIR}/${symbol}.c" @ONLY)
  configure_file(fw.h.in  "${CMAKE_CURRENT_BINARY_DIR}/${symbol}.h" @ONLY)
  configure_file(fw.rc.in "${CMAKE_CURRENT_BINARY_DIR}/${symbol}.rc" @ONLY)
  if (MSVC)
    enable_language(RC)
    set_source_files_properties("${PROJECT_NAME}.rc" OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${symbol}.rc")
    set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/${symbol}.rc" OBJECT_DEPENDS "${binary}")
  else()
    set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/${symbol}.c" OBJECT_DEPENDS "${binary}")
  endif()
  target_sources(${PROJECT_NAME} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/${symbol}.c")
endfunction()

target_binary( "${D4XX_FW_URL}"  "${D4XX_FW_VERSION}"  "${D4XX_FW_SHA1}" D4XX_FW_Image .bin)
target_binary( "${SR3XX_FW_URL}"  "${SR3XX_FW_VERSION}"  "${SR3XX_FW_SHA1}" SR3XX_FW_Image .bin)
target_binary( "${T26X_FW_URL}"  "${T26X_FW_VERSION}"  "${T26X_FW_SHA1}" target .mvcmd)
target_binary( "${L51X_FW_URL}"  "${L51X_FW_VERSION}"  "${L51X_FW_SHA1}" L51X_FW_Image .bin)
target_binary( "${L53X_FW_URL}"  "${L53X_FW_VERSION}"  "${L53X_FW_SHA1}" L53X_FW_Image .bin)



install(TARGETS ${PROJECT_NAME} EXPORT realsense2Targets
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== common/utilities/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.

target_sources(${LRS_TARGET}
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/time/common.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/stopwatch.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/timer.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/periodic_timer.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/waiting-on.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/work_week.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/work_week.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/time/l500/get-mfr-ww.h"
        "${CMAKE_CURRENT_LIST_DIR}/time/l500/get-mfr-ww.cpp"
)

include(${CMAKE_CURRENT_LIST_DIR}/os/CMakeLists.txt)

=== examples/gl-net/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2021 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamplesGLNet)

# Save the command line compile commands in the build output
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
endif()

if(BUILD_GRAPHICAL_EXAMPLES AND NOT APPLE)
    #pointcloud
    add_executable(rs-gl-net rs-gl-net.cpp ../example.hpp)
    target_link_libraries(rs-gl-net ${DEPENDENCIES} realsense2-gl realsense2-net)
    include_directories(../)
    set_target_properties (rs-gl-net PROPERTIES FOLDER Examples)
    install(TARGETS rs-gl-net RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/hdr/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2020 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamplesHdr)

if(BUILD_GRAPHICAL_EXAMPLES)
    add_executable(rs-hdr rs-hdr.cpp ../example.hpp ../../third-party/imgui/imgui.cpp ../../third-party/imgui/imgui_draw.cpp ../../third-party/imgui/imgui_impl_glfw.cpp)
    set_property(TARGET rs-hdr PROPERTY CXX_STANDARD 11)
    target_link_libraries(rs-hdr ${DEPENDENCIES})
    include_directories(../ ../../third-party/tclap/include ../../third-party/imgui ../../third-party/glfw/include)
    set_target_properties (rs-hdr PROPERTIES FOLDER "Examples")

    install(TARGETS rs-hdr RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/measure/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamplesMeasure)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

if(BUILD_GRAPHICAL_EXAMPLES)
    add_executable(rs-measure rs-measure.cpp ../example.hpp)
    set_property(TARGET rs-measure PROPERTY CXX_STANDARD 11)
    target_link_libraries(rs-measure ${DEPENDENCIES} Threads::Threads)
    include_directories(../)
    set_target_properties (rs-measure PROPERTIES FOLDER "Examples")

    install(TARGETS rs-measure RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/motion/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamplesMotion)

if(BUILD_GRAPHICAL_EXAMPLES)
    add_executable(rs-motion rs-motion.cpp ../example.hpp ../../common/res/d435.h ${LZ4_DIR}/lz4.c)
    set_property(TARGET rs-motion PROPERTY CXX_STANDARD 11)
    target_link_libraries(rs-motion ${DEPENDENCIES})
    include_directories(../ ../../common/res ${LZ4_DIR})
    set_target_properties (rs-motion PROPERTIES FOLDER Examples)
    install(TARGETS rs-motion RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/multicam/CMakeLists.txt ===
# License: Apache 2.0. See LICENSE file in root directory.
# Copyright(c) 2019 Intel Corporation. All Rights Reserved.
#  minimum required cmake version: 3.1.0
cmake_minimum_required(VERSION 3.1.0)

project(RealsenseExamplesMulticam)

if(BUILD_GRAPHICAL_EXAMPLES)
    add_executable(rs-multicam rs-multicam.cpp ../example.hpp)
    set_property(TARGET rs-multicam PROPERTY CXX_STANDARD 11)
    include_directories(../)
    target_link_libraries(rs-multicam ${DEPENDENCIES})
    set_target_properties (rs-multicam PROPERTIES FOLDER Examples)
    install(TARGETS rs-multicam RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== debian/changelog ===
ros-melodic-librealsense2 (2.50.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Sergey Dorodnicov <sergey.dorodnicov@intel.com>  Mon, 15 Nov 2021 07:51:30 -0000

=== debian/control ===
Source: ros-melodic-librealsense2
Section: misc
Priority: optional
Maintainer: Sergey Dorodnicov <sergey.dorodnicov@intel.com>
Build-Depends: debhelper (>= 9.0.0), dkms, libssl-dev, libudev-dev, libusb-1.0-0-dev, pkg-config, ros-melodic-catkin, udev
Homepage: https://github.com/IntelRealSense/librealsense/
Standards-Version: 3.9.2

Package: ros-melodic-librealsense2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: Library for capturing data from the Intel(R) RealSense(TM) SR300, D400, L500 Depth cameras and T2xx Tracking devices.
 This effort was initiated to better support researchers, creative coders, and app developers in domains such as robotics, virtual reality, and the internet of things. Several often-requested features of RealSense(TM); devices are implemented in this project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-librealsense2//opt/ros/melodic/lib/:$(CURDIR)/debian/ros-melodic-librealsense2//opt/ros/melodic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
